<template>
    <div class="card" style="width:100%;">

        <div class="card-body">
            <h5 class="card-title"> Title: {{ title }}</h5>
            <p class="card-text"> Description: {{ description }}</p>
            <p class="card-text"> Address: {{ address }}</p>
            <p class="card-text"> Rooms : {{ rooms }}</p>
            <p class="card-text"> Price : {{ price }} $</p>
            <p class="card-text"> Listing number: {{ id }}</p>
            <button type="button" v-if="!isInCart(id)&&button!=='false'" class="btn btn-primary"
                    @click.prevent="addToCart(id)">Add to
                cart
            </button>
            <button type="button" v-if="isInCart(id)" class="btn btn-danger" @click.prevent="removeFromCart(id)">Remove
                from
                Cart
            </button>
            <button type="button" v-if="(isAdmin || user_id === user.id) && this.$route.path !=='/cart'" class="btn btn-primary"
                    @click.prevent="toEdit(id)">Edit
            </button>
            <button type="button" v-if="(isAdmin || user_id === user.id) && this.$route.path !=='/cart'" class="btn btn-danger"
                    @click.prevent="deleteListing(id)">Delete
            </button>
        </div>
    </div>
</template>

<script>
    import {mapState} from "vuex";
    import {mapGetters} from "vuex";

    export default {
        name: "Listing",
        computed: {
            ...mapState({
                isAdmin: state => state.auth.role === 'admin',
                form: state => state.form
            }),
            ...mapGetters([
                'isInCart',
                'user',
                'getListing',
                'currentPage'
                // ...
            ])
        }
        ,
        methods: {
            addToCart(apartmentId) {
                this.$store.dispatch('addToCart', apartmentId).then(response => this.onSuccess(response)).catch(response => this.onError(response));
            },

            removeFromCart(apartmentId) {
                this.$store.dispatch('removeFromCart', apartmentId).then(response => this.onSuccess(response)).catch(response => this.onError(response));
            },
            onSuccess(response) {
                this.$store.dispatch('setCart', response.data)
                // this.$store.dispatch('setCurrentPage', response.data.current_page)
                // this.$store.dispatch('setLastPage', response.data.last_page)
            },
            onError(response) {
                console.log(response)
            },
            async deleteListing(id) {
                await this.$store.dispatch('deleteListing', id)
                await this.$store.dispatch('getCart',).then(response => this.$store.dispatch('setCart', response.data)).catch(response => this.onError(response));
                await this.$store.dispatch('getListings', this.form.populate({
                    page: this.currentPage,
                })).then(response => this.$store.dispatch('setListings', response.data)).catch(response => this.onError(response));

            },
            toEdit(id) {
                //console.log(this.getListing(id));
                // this.$store.dispatch('setEdited', this.getListing(id))
                this.$router.push('/editing-listing/' + id)
            }
        },
        props: {
            id: {required: true},
            user_id: {required: true},
            title: {required: true},
            description: {required: true},
            address: {required: true},
            rooms: {required: true},
            price: {required: true},
            button: {},
        }
    }
</script>

<style scoped>

</style>
